## McdPresenceFrame McdPresenceFrame — Presence maintenance framework |

## Stability Level

Unstable, unless otherwise indicated

## Synopsis

    #include <mcd-presence-frame.h>

                        McdPresenceFrame;
    McdPresenceFrame*   mcd_presence_frame_new              (void);
    void                mcd_presence_frame_request_presence (McdPresenceFrame *presence_frame,
                                                             McPresencepresence ,
                                                             const gchar *presence_message);
    McPresence          mcd_presence_frame_get_requested_presence
                                                            (McdPresenceFrame *presence_frame);
    const gchar*        mcd_presence_frame_get_requested_presence_message
                                                            (McdPresenceFrame *presence_frame);
    McPresence          mcd_presence_frame_get_actual_presence
                                                            (McdPresenceFrame *presence_frame);
    const gchar*        mcd_presence_frame_get_actual_presence_message
                                                            (McdPresenceFrame *presence_frame);
    void                mcd_presence_frame_set_account_presence
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account,
                                                             McPresencepresence ,
                                                             const gchar *presence_message);
    void                mcd_presence_frame_set_account_status
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account,
                                                             TpConnectionStatusconnection_status ,
                                                             TpConnectionStatusReasonconnection_reason );
    McPresence          mcd_presence_frame_get_account_presence
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account);
    TpConnectionStatus  mcd_presence_frame_get_account_status
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account);
    TpConnectionStatusReason mcd_presence_frame_get_account_status_reason
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account);
    void                mcd_presence_frame_set_accounts     (McdPresenceFrame *presence_frame,
                                                             const GList *accounts);
    gboolean            mcd_presence_frame_add_account      (McdPresenceFrame *presence_frame,
                                                             McAccount *account);
    gboolean            mcd_presence_frame_remove_account   (McdPresenceFrame *presence_frame,
                                                             McAccount *account);
    gboolean            mcd_presence_frame_cancel_last_request
                                                            (McdPresenceFrame *presence_frame);
    gboolean            mcd_presence_frame_is_stable        (McdPresenceFrame *presence_frame);

## Object Hierarchy

      GObject
       +----McdMission
             +----McdPresenceFrame

## Signals

      "presence-actual"                                : Run First
      "presence-changed"                               : Run First
      "presence-requested"                             : Run First
      "presence-stable"                                : Run First
      "status-actual"                                  : Run First
      "status-changed"                                 : Run First

## Description

FIXME

## Details

### McdPresenceFrame

    typedef struct _McdPresenceFrame McdPresenceFrame;

### mcd_presence_frame_new ()

    McdPresenceFrame*   mcd_presence_frame_new              (void);

Returns : |

### mcd_presence_frame_request_presence ()

    void                mcd_presence_frame_request_presence (McdPresenceFrame *presence_frame,
                                                             McPresencepresence ,
                                                             const gchar *presence_message);

`presence_frame` : |
`Param2` : |
`presence_message` : |

### mcd_presence_frame_get_requested_presence ()

    McPresence          mcd_presence_frame_get_requested_presence
                                                            (McdPresenceFrame *presence_frame);

`presence_frame` : |
Returns : |

### mcd_presence_frame_get_requested_presence_message ()

    const gchar*        mcd_presence_frame_get_requested_presence_message
                                                            (McdPresenceFrame *presence_frame);

`presence_frame` : |
Returns : |

### mcd_presence_frame_get_actual_presence ()

    McPresence          mcd_presence_frame_get_actual_presence
                                                            (McdPresenceFrame *presence_frame);

`presence_frame` : |
Returns : |

### mcd_presence_frame_get_actual_presence_message ()

    const gchar*        mcd_presence_frame_get_actual_presence_message
                                                            (McdPresenceFrame *presence_frame);

`presence_frame` : |
Returns : |

### mcd_presence_frame_set_account_presence ()

    void                mcd_presence_frame_set_account_presence
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account,
                                                             McPresencepresence ,
                                                             const gchar *presence_message);

`presence_frame` : |
`account` : |
`Param3` : |
`presence_message` : |

### mcd_presence_frame_set_account_status ()

    void                mcd_presence_frame_set_account_status
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account,
                                                             TpConnectionStatusconnection_status ,
                                                             TpConnectionStatusReasonconnection_reason );

`presence_frame` : |
`account` : |
`Param3` : |
`Param4` : |

### mcd_presence_frame_get_account_presence ()

    McPresence          mcd_presence_frame_get_account_presence
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account);

`presence_frame` : |
`account` : |
Returns : |

### mcd_presence_frame_get_account_status ()

    TpConnectionStatus  mcd_presence_frame_get_account_status
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account);

`presence_frame` : |
`account` : |
Returns : |

### mcd_presence_frame_get_account_status_reason ()

    TpConnectionStatusReason mcd_presence_frame_get_account_status_reason
                                                            (McdPresenceFrame *presence_frame,
                                                             McAccount *account);

`presence_frame` : |
`account` : |
Returns : |

### mcd_presence_frame_set_accounts ()

    void                mcd_presence_frame_set_accounts     (McdPresenceFrame *presence_frame,
                                                             const GList *accounts);

`presence_frame` : |
`accounts` : |

### mcd_presence_frame_add_account ()

    gboolean            mcd_presence_frame_add_account      (McdPresenceFrame *presence_frame,
                                                             McAccount *account);

`presence_frame` : |
`account` : |
Returns : |

### mcd_presence_frame_remove_account ()

    gboolean            mcd_presence_frame_remove_account   (McdPresenceFrame *presence_frame,
                                                             McAccount *account);

`presence_frame` : |
`account` : |
Returns : |

### mcd_presence_frame_cancel_last_request ()

    gboolean            mcd_presence_frame_cancel_last_request
                                                            (McdPresenceFrame *presence_frame);

`presence_frame` : |
Returns : |

### mcd_presence_frame_is_stable ()

    gboolean            mcd_presence_frame_is_stable        (McdPresenceFrame *presence_frame);

`presence_frame` : | The McdPresenceFrame.
Returns : | TRUE if there isn't any account currently trying to connect.

## Signal Details

### The `"presence-actual"` signal

    void                user_function                      (McdPresenceFrame *mcdpresenceframe,
                                                            gint              arg1,
                                                            gchar            *arg2,
                                                            gpointer          user_data)             : Run First

`mcdpresenceframe` : | the object which received the signal.
`arg1` : |
`arg2` : |
`user_data` : | user data set when the signal handler was connected.

### The `"presence-changed"` signal

    void                user_function                      (McdPresenceFrame *mcdpresenceframe,
                                                            GObject          *arg1,
                                                            gint              arg2,
                                                            gchar            *arg3,
                                                            gpointer          user_data)             : Run First

`mcdpresenceframe` : | the object which received the signal.
`arg1` : |
`arg2` : |
`arg3` : |
`user_data` : | user data set when the signal handler was connected.

### The `"presence-requested"` signal

    void                user_function                      (McdPresenceFrame *mcdpresenceframe,
                                                            gint              arg1,
                                                            gchar            *arg2,
                                                            gpointer          user_data)             : Run First

`mcdpresenceframe` : | the object which received the signal.
`arg1` : |
`arg2` : |
`user_data` : | user data set when the signal handler was connected.

### The `"presence-stable"` signal

    void                user_function                      (McdPresenceFrame *mcdpresenceframe,
                                                            gboolean          arg1,
                                                            gpointer          user_data)             : Run First

`mcdpresenceframe` : | the object which received the signal.
`arg1` : |
`user_data` : | user data set when the signal handler was connected.

### The `"status-actual"` signal

    void                user_function                      (McdPresenceFrame *mcdpresenceframe,
                                                            gint              arg1,
                                                            gpointer          user_data)             : Run First

`mcdpresenceframe` : | the object which received the signal.
`arg1` : |
`user_data` : | user data set when the signal handler was connected.

### The `"status-changed"` signal

    void                user_function                      (McdPresenceFrame *mcdpresenceframe,
                                                            GObject          *arg1,
                                                            gint              arg2,
                                                            gint              arg3,
                                                            gpointer          user_data)             : Run First

`mcdpresenceframe` : | the object which received the signal.
`arg1` : |
`arg2` : |
`arg3` : |
`user_data` : | user data set when the signal handler was connected.